import msgpack
import cv2
import numpy as np
from cv_blocks.geometry.pose import Pose

class SlamMap(object):
    '''
    Object holding SLAM Map generated by OpenVSLAM: https://github.com/xdspacelab/openvslam
    '''
    def __init__(self, map_file):
        self.map_file = map_file
        self.map_info = self.read_from_proto(map_file)
        self.scale = self.map_scale()
    
    def read_from_proto(self, map_file):
        print('Loading Map from %s' % map_file)
        with open(map_file, "rb") as f:
            map_info =  msgpack.unpackb(f.read())
        return map_info
    
    @staticmethod
    def convert_desc_to_uint8(desc_in):
        desc = np.asarray(desc_in, dtype=np.uint32).view(np.uint8)
        return desc
    
    def get_kf_descriptors(self, kf_id, subset_idx=None):
        desc = SlamMap.convert_desc_to_uint8(self.get_kf(kf_id)['descs'])
        if subset_idx is not None:
            desc = desc[subset_idx]
        return desc

    def get_kf_features(self, kf_id, subset_idx=None):
        feats = self.get_kf(kf_id)['keypts']
        feats = [cv2.KeyPoint(f['pt'][0], f['pt'][1], f['oct']) for f in feats]
        if subset_idx is not None:
            feats = [f for idx, f in enumerate(feats) if idx in subset_idx]
        return feats

    def get_kf_pose(self, kf_id):
        kf = self.get_kf(kf_id)
        return Pose((kf['rot_cw'], kf['trans_cw'])).inv()
    
    def get_kf_pts3d(self, kf_id):
        '''
        Returns 3d landmarks associated to features extracted from a keyframe.
        Also returns the feature index for each point
        '''
        # Find features accosiated to 3d point
        lm_ids = self.get_kf(kf_id)['lm_ids']
        valid_feat_idx = []
        valid_lm_id = []
        for feat_idx, lm_idx in enumerate(lm_ids):
            if lm_idx!=-1:
                valid_feat_idx.append(feat_idx)
                valid_lm_id.append(lm_idx)
        valid_feat_idx = np.array(valid_feat_idx, dtype=np.int)
        # Extract Valid 3d landmarks
        pts_3d = np.zeros((len(valid_lm_id), 3))
        for arr_idx, lm_idx in enumerate(valid_lm_id):
            pt_info = self.map_info['landmarks'][str(lm_idx)]
            pts_3d[arr_idx] = np.array(pt_info['pos_w'])

        return pts_3d, valid_feat_idx

    def kf_iter(self):
        for kf_id in sorted(self.map_info['keyframes'].keys(), key=lambda k : int(k)):
            kf_data = self.map_info['keyframes'][kf_id]
            yield (int(kf_id), kf_data)
    
    def get_kf(self, kf_id):
        return self.map_info['keyframes'][str(kf_id)]
    
    def get_kf_frame_ids(self):
        frame_ids = []
        keyframe_ids = []
        for id, kf_data in self.kf_iter():
            frame_ids.append(kf_data['src_frm_id'])
            keyframe_ids.append(id)
        return keyframe_ids, frame_ids
    
    def calc_kf_bows(self, dbow_fn):
        for kf_id, kf_data in self.map_info['keyframes'].items():
            # int32 -> uint8
            kf_desc = SlamMap.convert_desc_to_uint8(kf_data['descs'])
            kf_bow = dbow_fn(kf_desc)
            self.map_info['keyframes'][kf_id]['bow'] = kf_bow
    
    def map_scale(self):
        scale = 0.
        # define scale as the norm of the most distant kf from origin
        for _, kf_data in self.map_info['keyframes'].items():
            norm = np.linalg.norm(kf_data['trans_cw'])
            if norm > scale:
                scale = norm
        return scale
    
    def is_near_kfs(self, kf1, kf2, ratio=0.01):
        # KFs are near if their euclidean distance is smaller that ratio * map scale
        # TODO - take rotation into account
        kf_dist = np.linalg.norm(np.array(kf1['trans_cw']) - np.array(kf2['trans_cw']))
        return kf_dist < (ratio * self.scale)


if __name__=='__main__':
    map_file = '/home/walkout05/place_rec_data/walkout/map2.pb'
    my_map = SlamMap(map_file)